//=========================================================================
/** Java Bridge Design Pattern - einzelne Ware, Sicht des Verkufers
 *  Created on 15.11.2003
 */
//=========================================================================
import java.text.DecimalFormat;

public class BRVerkaeuferListeItem
{
   private String sBezeichnung   = null;
   private double fVerkaufspreis = 0.0;
   
   //---------------------------------------------------------------------------
   /**
    * Constructor
    */
   //---------------------------------------------------------------------------
   public BRVerkaeuferListeItem(BRModelItem pItem)
   {
      super();
      sBezeichnung   = new String (pItem.sBezeichnung);
      fVerkaufspreis = pItem.fEinkaufspreis + pItem.fEinkaufspreis * 1.2;
      fVerkaufspreis = fVerkaufspreis * 1.16;  
   }

   //---------------------------------------------------------------------------
   /**
    * toString
    */
   //---------------------------------------------------------------------------
   public String toString()
   {
      DecimalFormat df = new DecimalFormat("###,###,##0.00");
      StringBuffer  sb = new StringBuffer(80);
      
      sb.append(sBezeichnung);
      for (int i=sBezeichnung.length(); i<30; i++)
      {
         sb.append(".");
      }
      sb.append(": ");
      sb.append(df.format (fVerkaufspreis));
      sb.append(" ");
      
      return sb.toString();
   }
}
