//=========================================================================
/** Java Command Design Pattern - Rechteck
 */
//=========================================================================
import java.awt.Color;

public class CMRechteck implements ICMCommandListener
{
   private int   xKoordinate1 = 0;
   private int   yKoordinate1 = 0; 
   private int   xKoordinate2 = 0;
   private int   yKoordinate2 = 0; 
   private Color rFillColor   = null; 
   private Color rLineColor   = Color.black; 

   //----------------------------------------------------------------------
   public CMRechteck(int px1, int py1, int px2, int py2)
   {
      super();
      xKoordinate1 = px1; 
      yKoordinate1 = py1;
      xKoordinate2 = px2; 
      yKoordinate2 = py2;
   }
   
   //----------------------------------------------------------------------
   public void doCommand (CMCommand pCommand)
   {
      if (pCommand.getCommandText().equals("Fillcolor"))
      {
         rFillColor = (Color)(pCommand.getData());
      }
      else if (pCommand.getCommandText().equals("Linecolor"))
      {
         rLineColor = (Color)(pCommand.getData());
      }
      else if (pCommand.getCommandText().equals("Resize"))
      {
         int nDiff = 0;
         nDiff = xKoordinate2 - xKoordinate1;
         nDiff = (int)(nDiff * ((Double)(pCommand.getData())).doubleValue());
         xKoordinate2 = xKoordinate1 + nDiff;

         nDiff = yKoordinate2 - yKoordinate1;
         nDiff = (int)(nDiff * ((Double)(pCommand.getData())).doubleValue());
         yKoordinate2 = yKoordinate1 + nDiff;
      }
   }
   
   //----------------------------------------------------------------------
   public String toString()
   {
      StringBuffer sb = new StringBuffer();
      sb.append ("Rechteck: " + xKoordinate1 + ", " + yKoordinate1 + ", " 
                              + xKoordinate2 + ", " + yKoordinate2 + ", Line: " 
                              + rLineColor + ", Fill: " + rFillColor);
      return sb.toString();
   }
}
