//=========================================================================
/** Java Command Design Pattern - Testprogramm
 */
//=========================================================================
import java.awt.Color;
import java.util.Vector;

public class Command
{
   //----------------------------------------------------------------------
   // Hauptprogramm
   //----------------------------------------------------------------------      
   public static void main(String[] args)
   {
      Vector             vCommandListener = new Vector();
      ICMCommandListener rListener        = null;
      CMCommandResize    rResize          = new CMCommandResize(); 
      CMCommandFillcolor rFill            = new CMCommandFillcolor(); 
      CMCommandLinecolor rLine            = new CMCommandLinecolor(); 
      
      rResize.setData(new Double(0.5));
      rFill.setData(Color.red);
      rLine.setData(Color.blue);
      
      vCommandListener.add(new CMPunkt( 10,  10));
      vCommandListener.add(new CMPunkt(100, 100));
      vCommandListener.add(new CMKreis( 50,  50, 100));
      vCommandListener.add(new CMKreis( 20,  20,  11));
      vCommandListener.add(new CMRechteck( 25,  25, 125, 125));
      vCommandListener.add(new CMRechteck(200, 200, 300, 300));
      
      //---------------------------------------------------------------------
      // Ausgeben
      //---------------------------------------------------------------------
      for (int i=0; i<vCommandListener.size(); i++)
      {
         System.out.println(vCommandListener.elementAt(i).toString());
      }
      System.out.println("----------------------");
      
      //---------------------------------------------------------------------
      // Gre ndern
      //---------------------------------------------------------------------
      for (int i=0; i<vCommandListener.size(); i++)
      {
         if (vCommandListener.elementAt(i) instanceof ICMCommandListener)
         {
            rListener = (ICMCommandListener)vCommandListener.elementAt(i);
            rListener.doCommand(rResize); 
         }
      }

      //---------------------------------------------------------------------
      // Ausgeben
      //---------------------------------------------------------------------
      for (int i=0; i<vCommandListener.size(); i++)
      {
         System.out.println(vCommandListener.elementAt(i).toString());
      }
      System.out.println("----------------------");

      //---------------------------------------------------------------------
      // Farben ndern
      //---------------------------------------------------------------------
      for (int i=0; i<vCommandListener.size(); i++)
      {
         if (vCommandListener.elementAt(i) instanceof ICMCommandListener)
         {
            rListener = (ICMCommandListener)vCommandListener.elementAt(i);
            rListener.doCommand(rFill); 
            rListener.doCommand(rLine); 
         }
      }

      //---------------------------------------------------------------------
      // Ausgeben
      //---------------------------------------------------------------------
      for (int i=0; i<vCommandListener.size(); i++)
      {
         System.out.println(vCommandListener.elementAt(i).toString());
      }
   }
}
