//=========================================================================
/** Java Decorator Pattern - Decorator fr Dollar-Zone
 */
//=========================================================================
public class DCDecoratorUS extends DCDecoratorWareBasis implements DCIDecoratorBasis
{
   //-------------------------------------------------------------------------
   // Constructor
   //-------------------------------------------------------------------------
   public DCDecoratorUS (DCWare rNewWare)
   {
      super (rNewWare);
   }

   //-------------------------------------------------------------------------
   // getVKPreis ()
   //-------------------------------------------------------------------------
   public double getVKPreis ()
   {
      return rWare.getEKPreis() * getProfitfactor() + getTax();
   }

   //-------------------------------------------------------------------------
   // getTax ()
   //-------------------------------------------------------------------------
   public double getTax ()
   {
      return rWare.getEKPreis() * getCountyTaxfactor() +
             rWare.getEKPreis() * getStateTaxfactor()  +
             rWare.getEKPreis() * getFederalTaxfactor();
   }

   //-------------------------------------------------------------------------
   // getStateTaxfactor ()
   //-------------------------------------------------------------------------
   private double getStateTaxfactor ()
   {
      return 0.07; // BESSER: aus externer Datenbank lesen
   }

   //-------------------------------------------------------------------------
   // getFederalTaxfactor ()
   //-------------------------------------------------------------------------
   private double getFederalTaxfactor ()
   {
      return 0.04; // BESSER: aus externer Datenbank lesen
   }

   //-------------------------------------------------------------------------
   // getCountyTaxfactor ()
   //-------------------------------------------------------------------------
   private double getCountyTaxfactor ()
   {
      return 0.05; // BESSER: aus externer Datenbank lesen
   }

   //-------------------------------------------------------------------------
   // getProfitfactor ()
   //-------------------------------------------------------------------------
   public double getProfitfactor ()
   {
      return 2.0; // BESSER: aus externer Datenbank lesen 
                 // zB. gem Warengruppe
   }
}
