//=========================================================================
/** Java Prototype Design Pattern - Testprogramm
 */
//=========================================================================
import java.util.Random;
import java.util.Vector;

public class Prototype
{
   //----------------------------------------------------------------------
   // Hauptprogramm
   //----------------------------------------------------------------------      
   public static void main(String[] args)
   {
      Random rRand     = new Random (System.currentTimeMillis());
      Vector vElements = new Vector();
      Vector vCopy     = new Vector();
      
      // 10 zufllige Elemente erzeugen
      for (int i=0; i<10; i++)
      {
         switch (Math.abs(rRand.nextInt()) % 3)
         {
            case  0:
                  vElements.add(new PRKreis(rRand.nextInt(), rRand.nextInt(), 
                                            rRand.nextInt()));
                  break;
            case  1:
                  vElements.add(new PRLinie(rRand.nextInt(), rRand.nextInt(), 
                                            rRand.nextInt(), rRand.nextInt()));
                  break;
            case  2:
                  vElements.add(new PRRechteck(rRand.nextInt(), rRand.nextInt(), 
                                               rRand.nextInt(), rRand.nextInt()));
                  break;
         }
      }
      
      // 10 zufllig erzeugte Elemente ausgeben
      for (int i=0; i<10; i++)
      {
         System.out.println (vElements.elementAt(i).toString());
      }
      System.out.println ("-----------------------");
      
      // 10 zufllig erzeugte Elemente kopieren
      for (int i=0; i<10; i++)
      {
         vCopy.add (((PRGraphicElement)vElements.elementAt(i)).clone());
      }

      // 10 zufllig erzeugte Elemente ausgeben
      for (int i=0; i<10; i++)
      {
         System.out.println (vCopy.elementAt(i).toString());
      }
   }
}
