//=========================================================================
/** Java Proxy Design Pattern - Testprogramm
 */
//=========================================================================
public class Proxy
{
   //----------------------------------------------------------------------
   // Hauptprogramm
   //----------------------------------------------------------------------      
   public static void main(String[] args)
   {
      // Testdaten erzeugen
      PXDatalist rData = new PXDatalist(); 
      rData.add(new PXDatalistItem("Donald",   "Duck", 1));
      rData.add(new PXDatalistItem("Dagobert", "Duck", 2));
      rData.add(new PXDatalistItem("Micky",    "Maus", 3));
      rData.add(new PXDatalistItem("Minnie",   "Maus", 4));
      
      // Visitor-Proxy fr Datenzugriff erzeugen
      PXVisitorProxy rVisitor = new PXVisitorProxy(rData);
      System.out.println("--- VISITOR 1 ---");
      rVisitor.anzeigen();
      rVisitor.anlegen("Gustav", "Gans", 5);
      rVisitor.aendern(0, "Daisy", "Duck", 1);
      rVisitor.loeschen(2);
      System.out.println("\n--- VISITOR 2 ---");
      rVisitor.anzeigen();

      // Administrator-Proxy fr Datenzugriff erzeugen
      PXAdministratorProxy rAdmin = new PXAdministratorProxy(rData);
      System.out.println("\n--- ADMINSITRATOR 1 ---");
      rAdmin.anzeigen();
      rAdmin.anlegen("Gustav", "Gans", 5);
      rAdmin.aendern(0, "Daisy", "Duck", 1);
      rAdmin.loeschen(2);
      System.out.println("\n--- ADMINSITRATOR 2 ---");
      rAdmin.anzeigen();
   }
}
